program multicom1;

uses dos, crt, graph, mycrt;

const NumCommodities = 5;  {or whatever number is wanted}

type InventoryControlType = array[1..NumCommodities] of
                           record
                            Price,     {converts to effect on cash reserve}
                            PurchRate, { output variable}
                            UseRate,   { disturbance}
                            DeprecRate, {disturbance}
                            DesiredInventory, {reference level}
                            Inventory,  {controlled variable}
                            CommGain: double;
                           end;

      IncomeControlType =  record
                            CostRate, {for substraction from reserve}
                            DesiredIncomeRate, {reference signal}
                            IncomeRate,        { controlled variable}
                            HoursWorkedPerDay, {output variable}
                            IncomeGain,        {output gain factor}
                            IncomeRateError,   {error signal}
                            Payrate,           {converts work to income}
                            IncomeSlow: double; {slowing factor}
                          end;

    ReserveControlType = record
                          Reserve,             { controlled variable}
                          DesiredReserve,      { reference signal}
                          ReserveError,        { error signal}
                          ReserveGain,         { output gain}
                          ConsumptionGain,     {gain, effect on consumption}
                          suppression: double;
                         end;

var CommodityControl: InventoryControlType;
    IncomeControl: IncomeControlType;
    ReserveControl: ReserveControlType;
    dt: double;

{ARRAY OF INVENTORY CONTROLLERS, ONE FOR EACH COMMODITY}
procedure InventoryControl;
var i: integer;
begin
 for i := 1 to NumCommodities do
 with CommodityControl[i] do { "with" statement applies to begin--end}
 begin
  {ENTIRE CONTROL SYSTEM IN ONE LINE}
  PurchRate := CommGain*(DesiredInventory          {REF SIGNAL}
                     - ReserveControl.suppression  {LOWERS REF SIGNAL}
                     - inventory                   {PERCEPTUAL SIGNAL}
                     );
  inventory := inventory +       {sum up effects on inventory}
                (PurchRate  - UseRate - DeprecRate*Inventory)*dt;
 end;
end;

{CONTROLLER FOR INCOME RATE (NOT REALLY REQUIRED, COULD JUST USE THE
 REFERENCE SIGNAL TO BE THE RATE OF INCOME, DOLLARS PER DAY}
procedure IncomeController;
var i: integer;
begin
 with IncomeControl do
 begin
  costRate := 0;
  for i := 1 to NumCommodities do {SUM COSTS FROM ALL INVENTORY CONTROLLERS}
  with CommodityControl[i] do
   CostRate := CostRate + PurchRate*Price; { RATE = DOLLARS PER DAY}
  with IncomeControl do
  begin
   IncomeRateError :=DesiredIncomeRate - IncomeRate;
   HoursWorkedPerDay := HoursWorkedPerDay +      {OUTPUT VARIABLE}
                        (
                         IncomeGain*IncomeRateError -
                         HoursWorkedPerDay
                        )
                        *dt/IncomeSlow;    {LEAKY INEGRATOR}
   IncomeRate := HoursWorkedPerDay* PayRate;
  end; {AS I SAID, WE COULD JUST SAY INCOMERATE = DESIREDINCOMERATE}
 end;
end;

{PROPORTIONAL CONTROLLER FOR CASH RESERVE. ERROR LEADS TO INCREASE IN HOURS
 WORKED, EQUAL DECREASES IN REFERENCE LEVELS FOR ALL COMMODITIES}
procedure ReserveController;
begin
 with IncomeControl, ReserveControl do
 begin
  Reserve := Reserve + (IncomeRate - CostRate)*dt; {PERCEPT SIGNAL}
  ReserveError := DesiredReserve - Reserve;        {ERROR SIGNAL}
  DesiredIncomeRate := ReserveGain*ReserveError;   {OUTPUT TO INCOME CONTROL}
  suppression := ConsumptionGain*ReserveError;     {SUPPRESSON OF PURCHASES}
 end;
end;

begin
 {INITIALIZATION AND MAIN PROGRAM HERE}
end.


